﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Configuration;
using System.Data.SqlClient;

namespace WebApplication1
{
    public class FizetesModManager
    {
        public static List<FMod> GetItems()
        {
            List<FMod> ret = new List<FMod>();

            string connStr = ConfigurationManager.ConnectionStrings["KFConnectionString"].ToString();

            using (SqlConnection conn = new SqlConnection(connStr))
            {
                SqlCommand cmd = new SqlCommand("");
                cmd.Connection = conn;
                cmd.CommandText = "SELECT * FROM FizetesMod";

                conn.Open();

                SqlDataReader dr = null;
                try
                {
                    dr = cmd.ExecuteReader();
                    while (dr.Read())
                    {
                        ret.Add(new FMod {
                            ID = Convert.ToInt32( dr["ID"].ToString() ),
                            Mod = dr["Mod"].ToString(),
                            Hatarido = Convert.ToInt32( dr["Hatarido"].ToString() ),
                            Verzio = Convert.ToInt32( dr["Verzio"].ToString() )
                        });
                    }
                }
                finally
                {
                    if (dr != null)
                    {
                        dr.Close();
                    }
                }
            }

            return ret;
        }
        
        public static void UpdateFMod(FMod fm)
        {
            string connStr = ConfigurationManager.ConnectionStrings["KFConnectionString"].ToString();

            using (SqlConnection conn = new SqlConnection(connStr))
            {
                SqlCommand cmd = new SqlCommand("");
                cmd.Connection = conn;
                cmd.CommandText = "SELECT * FROM FizetesMod WITH(rowlock) WHERE id=@id";
                cmd.Parameters.AddWithValue("id", fm.ID);

                conn.Open();

                SqlTransaction tr = conn.BeginTransaction();
                cmd.Transaction = tr;
                
                SqlDataReader dr = null;
                try
                {
                    dr = cmd.ExecuteReader();
                    dr.Read();
                    int oldVersion = Convert.ToInt32(dr["Verzio"]);
                    if (oldVersion > fm.Verzio)
                    {
                        throw new Exception("Modositottak a rekordot!");
                    }

                }
                catch (SqlException)
                {
                }
                catch (Exception)
                {
                    dr.Close();
                    conn.Close();
                    throw;
                }
                finally
                {
                    dr.Close();
                }

                SqlCommand cmd2 = new SqlCommand();
                cmd2.Connection = conn;
                cmd2.CommandText = "UPDATE FizetesMod SET Mod = @mod, Hatarido = @hatarido, Verzio = @verzio WHERE ID=@id";
                cmd2.Parameters.AddWithValue("mod", fm.Mod);
                cmd2.Parameters.AddWithValue("hatarido", fm.Hatarido);
                cmd2.Parameters.AddWithValue("verzio", fm.Verzio + 1);
                cmd2.Parameters.AddWithValue("id", fm.ID);
                cmd2.Transaction = tr;

                try
                {
                    cmd2.ExecuteNonQuery();
                    tr.Commit();
                }
                catch (SqlException)
                {

                }
                finally
                {
                    conn.Close();
                }
            }
        }
        
        public static void DeleteFMod(FMod fm)
        {
            string connStr = ConfigurationManager.ConnectionStrings["KFConnectionString"].ToString();

            using (SqlConnection conn = new SqlConnection(connStr))
            {
                SqlCommand cmd = new SqlCommand("");
                cmd.Connection = conn;
                cmd.CommandText = "SELECT * FROM FizetesMod WITH(rowlock) WHERE id=@id";
                cmd.Parameters.AddWithValue("id", fm.ID);

                conn.Open();

                SqlTransaction tr = conn.BeginTransaction();
                cmd.Transaction = tr;

                SqlDataReader dr = null;
                try
                {
                    dr = cmd.ExecuteReader();
                    if (!dr.HasRows)
                    {
                        throw new Exception("Már törölték a rekordot!");
                    }

                    if (Convert.ToInt32(dr["Verzio"].ToString()) > fm.Verzio)
                    {
                        throw new Exception("Valaki már frissítette a rekordot, nem törölhető!");
                    }
                }
                catch (SqlException)
                {
                }
                catch (Exception)
                {
                    dr.Close();
                    conn.Close();
                    throw;
                }
                finally
                {
                    dr.Close();
                }

                SqlCommand cmd2 = new SqlCommand();
                cmd2.Connection = conn;
                cmd2.CommandText = "DELETE FROM FizetesMod WHERE ID=@id";
                cmd2.Parameters.AddWithValue("id", fm.ID);
                cmd2.Transaction = tr;

                try
                {
                    cmd2.ExecuteNonQuery();
                    tr.Commit();
                }
                catch (SqlException)
                {

                }
                finally
                {
                    conn.Close();
                }
            }
        }
        
        public static void InsertFMod(FMod fm)
        {
        }
    }
}
